Index: apps/app_voicemail.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_voicemail.c,v
retrieving revision 1.237
diff -u -r1.237 app_voicemail.c
--- apps/app_voicemail.c	3 Aug 2005 02:45:30 -0000	1.237
+++ apps/app_voicemail.c	14 Aug 2005 20:10:47 -0000
@@ -2224,18 +2224,25 @@
 				return ERROR_LOCK_PATH;
 			}
 
-			if (res >= 0) {
-				/* Unless we're *really* silent, try to send the beep */
-				res = ast_streamfile(chan, "beep", chan->language);
-				if (!res)
-					res = ast_waitstream(chan, "");
-			}
+			/* 
+			 * This operation can be very expensive if done say over NFS or if the mailbox has 100+ messages
+			 * in the mailbox.  So we should get this first so we don't cut off the first few seconds of the 
+			 * message.  
+			 */
 			do {
 				make_file(fn, sizeof(fn), dir, msgnum);
 				if (!EXISTS(dir,msgnum,fn,chan->language))
 					break;
 				msgnum++;
 			} while (msgnum < vmu->maxmsg);
+
+			/* Now play the beep once we have the message number for our next message. */
+			if (res >= 0) {
+				/* Unless we're *really* silent, try to send the beep */
+				res = ast_streamfile(chan, "beep", chan->language);
+				if (!res)
+					res = ast_waitstream(chan, "");
+			}
 			if (msgnum < vmu->maxmsg) {
 				/* assign a variable with the name of the voicemail file */	  
 				pbx_builtin_setvar_helper(chan, "VM_MESSAGEFILE", fn);
